<template>
  <div>
    <section class="primary darken-4 mb-3 white--text py-5">
      <v-container>
        <div class="d-flex flex-row">
          <div class="d-flex flex-column justify-center mr-5">
            <v-avatar color="accent" rounded size="130">
              <img alt="Avatar" :src="user.avatar">
            </v-avatar>
          </div>
          <div class="py-3 text-center text-sm-left">
            <div class="text-h4">
              <b>{{ user.firstName }}</b> <small>{{ user.lastName }}</small>
            </div>
            <div class="text-h6">
              <small>{{ user.email }}</small>
            </div>
          </div>
        </div>
      </v-container>
    </section>
    <section>
      <v-container grid-list-md>
        <v-card v-if="this.allDataAppointmentsOfUser.length === 0" class="mt-8 mb-4">
          <v-card-title>
            <b>Vous n'avez pas encore de rendez-vous. </b>
          </v-card-title>
        </v-card>

        <v-card elevation="0" class="mt-12 pa-4 w-100" justify="center" :key="appointment.idAppointment"
                v-for=" (appointment, index) in this.allDataAppointmentsOfUser">
          <v-row class="bg-cyan">
            <v-card-title>
              {{ appointment.date | moment }}
            </v-card-title>
          </v-row>
          <v-divider></v-divider>
          <v-card-text>
            <v-avatar class="mr-4 mb-2">
              <v-img
                  :src="user.avatar"
              ></v-img>
            </v-avatar>
            <b>{{ appointment.proLastName | uppercase }} {{ appointment.proFirstName | capitalize }}</b>
            <p>Type de soin : <b> {{ appointment.typeCareLabel }} </b></p>
            <v-divider class="mb-4"></v-divider>

            <i aria-hidden="true" class="mr-4 v-icon notranslate mdi mdi-phone theme--light"></i>
            <b>Numéro de téléphone</b>
            <p class="ml-10">{{ appointment.phoneNumber }}</p>
            <v-divider class="mb-4 mt-4"></v-divider>

            <i aria-hidden="true" class="mr-4 v-icon notranslate mdi mdi-account theme--light"></i>
            <b>Nom du patient</b>
            <p class="ml-10">{{ appointment.clientLastName | uppercase }}
              {{ appointment.clientFirstName | capitalize }}</p>
            <v-divider class="mb-4 mt-4"></v-divider>

            <i aria-hidden="true" class="mr-4 v-icon notranslate mdi mdi-map-marker   theme--light"></i>
            <b>Se rendre au rendez-vous</b>
            <div>
              <div class="ml-10">{{ appointment.name }}</div>
              <div class="ml-10">{{ appointment.address }}</div>
              <div class="ml-10">{{ appointment.postalCode }}</div>
              <div class="mt-5">

                <iframe width="100%" height="250" frameborder="0" style="border:0"
                        :src="fullAddress(index)"
                >
                </iframe>

              </div>
            </div>
            <v-divider class="mb-4 mt-4"></v-divider>
          </v-card-text>
          <v-card-actions class="d-flex flex-row-reverse">
            <v-btn large color="error" @click="deleteAppointmentDialog(appointment.idAppointment)">Annuler</v-btn>
          </v-card-actions>
        </v-card>
        <v-dialog v-model="dialogDeleteAppointment" max-width="580px">
          <v-card>
            <v-card-title class="headline">Etes-vous sûr de vouloir annuler ce rendez-vous ?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="closeDeleteAppointmentDialog">Annuler</v-btn>
              <v-btn color="blue darken-1" text @click="confirmDeleteAppointmentDialog">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-snackbar
            v-model="confirmDeleteSnackbar"
            :timeout=2000
        >
          Votre rendez-vous à été annulé.
          <v-btn
              color="blue"
              dark large
              @click="confirmDeleteSnackbar = false"
          >
            Fermer
          </v-btn>
        </v-snackbar>

      </v-container>
    </section>
  </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';
import moment from "moment";

export default {
  name: 'Appointments',
  data: () => ({
    arrayOfIframeGoogleMaps: [],
    allDataAppointmentsOfUser: [],
    AllCareTypes: [],
    currentAppointmentIdToDelete: null,
    dialogDeleteAppointment: false,
    confirmDeleteSnackbar: false
  }),
  methods: {
    ...mapActions(['loadAppointmentsByIdUser', 'deleteAppointment', 'loadCareType', 'loadCurrentUser']),
    openAvatarPicker() {
    },
    fullAddress(index) {
      return `https://maps.google.com/maps?hl=fr&q=${this.arrayOfIframeGoogleMaps[index]}&ie=UTF8&z=13&output=embed`;
    },
    deleteAppointmentDialog(appointmentId) {
      this.dialogDeleteAppointment = true
      this.currentAppointmentIdToDelete = appointmentId;
    },
    closeDeleteAppointmentDialog() {
      this.dialogDeleteAppointment = false;
      this.currentAppointmentIdToDelete = null;
    },
    confirmDeleteAppointmentDialog() {
      this.deleteAppointment(this.currentAppointmentIdToDelete)
          .then(() => {
            this.dialogDeleteAppointment = false;
            this.confirmDeleteSnackbar = true;
            this.updateAppointments();

          });
    },

    async updateAppointments() {
      //Waiting for user global be ready
      await this.loadCurrentUser(localStorage.getItem('token'));
      if (typeof this.user.id !== undefined) {

        //Send Request For set All Appointment of the Current user
        await this.loadAppointmentsByIdUser(this.user.id);
        let allAppointmentsOfUserBrutData = this.getUserAppointments;

        //We get all the brut data of the appoitnment of the current user
        if (typeof allAppointmentsOfUserBrutData['hydra:member'] !== 'undefined'
            && allAppointmentsOfUserBrutData['hydra:member'].length > 0) {
          this.allDataAppointmentsOfUser = [];

          for (const element of allAppointmentsOfUserBrutData['hydra:member']) {
            let allDataAppointmentsOfUserTmp = [];

            //On Cree Un tableau permetant de mettre en cache les labels des care_type déja connues, pour limiter les envoies de requêttes.
            if (typeof this.AllCareTypes[element.care.type] === 'undefined') {
              await this.loadCareType(element.care.type);

              if (typeof this.getCurrentCareType !== 'undefined' && this.getCurrentCareType !== null &&
                  typeof this.getCurrentCareType.label !== 'undefined' && this.getCurrentCareType.label !== null) {
                this.AllCareTypes[element.care.type] = this.getCurrentCareType.label;
              } else {
                this.AllCareTypes[element.care.type] = 'non spécifié';
              }
            }

            //Format array for make easier the renderer, cause it's a Join of 5 Tables In ApiPlatform & Prisma graphQL

            //Office Part
            allDataAppointmentsOfUserTmp["idOffice"] = (typeof element.care.office.id !== 'undefined') ? element.care.office.id : null
            allDataAppointmentsOfUserTmp["name"] = (typeof element.care.office.name !== 'undefined') ? element.care.office.name : null
            allDataAppointmentsOfUserTmp["address"] = (typeof element.care.office.address !== 'undefined') ? element.care.office.address : null
            allDataAppointmentsOfUserTmp["city"] = (typeof element.care.office.city !== 'undefined') ? element.care.office.city : null
            allDataAppointmentsOfUserTmp["postalCode"] = (typeof element.care.office.postalCode !== 'undefined') ? element.care.office.postalCode : null
            allDataAppointmentsOfUserTmp["country"] = (typeof element.care.office.country !== 'undefined') ? element.care.office.country : null
            allDataAppointmentsOfUserTmp["description"] = (typeof element.care.office.description !== 'undefined') ? element.care.office.description : null
            allDataAppointmentsOfUserTmp["email"] = (typeof element.care.office.email !== 'undefined') ? element.care.office.email : null
            allDataAppointmentsOfUserTmp["phoneNumber"] = (typeof element.care.office.phoneNumber !== 'undefined') ? element.care.office.phoneNumber : null

            //Appointment Part
            allDataAppointmentsOfUserTmp["idAppointment"] = (typeof element.id !== 'undefined') ? element.id : null
            allDataAppointmentsOfUserTmp["date"] = (typeof element.date !== 'undefined') ? element.date : null

            //Care_Type Part
            allDataAppointmentsOfUserTmp["typeCareLabel"] = (typeof this.AllCareTypes[element.care.type] !== 'undefined' && this.AllCareTypes[element.care.type] !== null) ? this.AllCareTypes[element.care.type] : 'non spécifié'

            //User_Pro Recap
            allDataAppointmentsOfUserTmp["proLastName"] = (typeof element.care.pro.lastName !== 'undefined') ? element.care.pro.lastName : null
            allDataAppointmentsOfUserTmp["proFirstName"] = (typeof element.care.pro.firstName !== 'undefined') ? element.care.pro.firstName : null

            //User_Client Recap
            allDataAppointmentsOfUserTmp["clientLastName"] = (typeof element.client.lastName !== 'undefined') ? element.client.lastName : null
            allDataAppointmentsOfUserTmp["clientFirstName"] = (typeof element.client.firstName !== 'undefined') ? element.client.firstName : null

            //Concat All Array to one
            this.allDataAppointmentsOfUser.push(allDataAppointmentsOfUserTmp)
            //Array for send request to Google Maps
            this.arrayOfIframeGoogleMaps.push(allDataAppointmentsOfUserTmp["address"]);
          }
        }else{
          this.allDataAppointmentsOfUser = [];
        }
      }
    },
  },
  computed: {
    ...mapGetters(['user', 'getUserAppointments', 'getCurrentCareType', 'careTypes']),

  },
  filters: {
    moment: function (date) {
      return moment(date).format('LLLL');
    },
    capitalize: function (value) {
      if (!value) return ''
      value = value.toString()
      return value.charAt(0).toUpperCase() + value.slice(1)
    },
    uppercase: function (value) {
      if (!value) return ''
      value = value.toString()
      return value.toUpperCase();
    },
  },
  mounted() {
    this.updateAppointments();
  },
}
</script>
<style scoped lang="scss">
.bg-cyan {
  color: #44c8cd;
}
</style>